export declare type CacheKey = string | (string | object)[];
export interface CacheData {
    value: any;
    date: number;
    invalid: boolean;
    hitCount: number;
}
export interface CacheKeys {
    keys?: {
        [key: string]: CacheKeys;
    };
    data?: CacheData;
}
export declare type CacheState = CacheKeys;
export interface CacheConfig {
    expires: number;
}
export declare function hashKey(key: CacheKey): string[];
export declare function getCacheValue(keys: string[], state: CacheState): CacheData | undefined;
export declare function isCacheValid(cache: CacheData, exp: number): boolean;
