function hash(key) {
    return JSON.stringify(key, (_, val) => typeof val == 'object'
        ? Object.keys(val)
            .sort()
            .reduce((result, k) => {
            result[k] = val[k];
            return result;
        }, {})
        : val);
}
export function hashKey(key) {
    return typeof key === 'string'
        ? [key]
        : key.map((k) => {
            return typeof k === 'string' ? k : hash(k);
        });
}
export function getCacheValue(keys, state) {
    var _a;
    let parent = state;
    for (const key of keys) {
        parent = (_a = parent === null || parent === void 0 ? void 0 : parent.keys) === null || _a === void 0 ? void 0 : _a[key];
        if (!parent)
            return undefined;
    }
    return parent === null || parent === void 0 ? void 0 : parent.data;
}
export function isCacheValid(cache, exp) {
    return !cache.invalid && Date.now() <= cache.date + exp;
}
//# sourceMappingURL=cache.models.js.map