import { Injectable } from '@angular/core';
import { TraitEffect } from 'ngrx-traits';
import { asyncScheduler, EMPTY, of, pipe, timer } from 'rxjs';
import { concatMap, debounce, distinctUntilChanged, first, map, pairwise, startWith, } from 'rxjs/operators';
import { createEffect, ofType } from '@ngrx/effects';
import * as i0 from "@angular/core";
export function createFilterTraitEffects(allActions, allSelectors, allConfigs) {
    const traitConfig = allConfigs.filter;
    class FilterEffect extends TraitEffect {
        constructor() {
            super(...arguments);
            this.storeFilter$ = createEffect(() => ({ debounce: debounceTime = traitConfig.defaultDebounceTime, scheduler = asyncScheduler, } = {}) => this.actions$.pipe(ofType(allActions.filterEntities), debounce((value) => (value === null || value === void 0 ? void 0 : value.forceLoad) ? EMPTY : timer(debounceTime, scheduler)), concatMap((payload) => payload.patch
                ? this.store.select(allSelectors.selectEntitiesFilter).pipe(first(), map((storedFilters) => (Object.assign(Object.assign({}, payload), { filters: Object.assign(Object.assign({}, storedFilters), payload === null || payload === void 0 ? void 0 : payload.filters) }))))
                : of(payload)), distinctUntilChanged((previous, current) => !(current === null || current === void 0 ? void 0 : current.forceLoad) &&
                JSON.stringify(previous === null || previous === void 0 ? void 0 : previous.filters) ===
                    JSON.stringify(current === null || current === void 0 ? void 0 : current.filters)), (traitConfig === null || traitConfig === void 0 ? void 0 : traitConfig.isRemoteFilter)
                ? pipe(startWith({
                    filters: traitConfig.defaultFilter,
                    patch: false,
                }), pairwise(), concatMap(([previous, current]) => (traitConfig === null || traitConfig === void 0 ? void 0 : traitConfig.isRemoteFilter(previous === null || previous === void 0 ? void 0 : previous.filters, current === null || current === void 0 ? void 0 : current.filters))
                    ? [
                        allActions.storeEntitiesFilter({
                            filters: current === null || current === void 0 ? void 0 : current.filters,
                            patch: current === null || current === void 0 ? void 0 : current.patch,
                        }),
                        allActions.loadEntities(),
                    ]
                    : [
                        allActions.storeEntitiesFilter({
                            filters: current === null || current === void 0 ? void 0 : current.filters,
                            patch: current === null || current === void 0 ? void 0 : current.patch,
                        }),
                    ]))
                : map((action) => allActions.storeEntitiesFilter({
                    filters: action === null || action === void 0 ? void 0 : action.filters,
                    patch: action === null || action === void 0 ? void 0 : action.patch,
                }))));
            this.loadEntities$ = (!(traitConfig === null || traitConfig === void 0 ? void 0 : traitConfig.filterFn) || (traitConfig === null || traitConfig === void 0 ? void 0 : traitConfig.isRemoteFilter)) &&
                createEffect(() => {
                    return this.actions$.pipe(ofType(allActions['storeEntitiesFilter']), concatMap(() => (allActions === null || allActions === void 0 ? void 0 : allActions.loadEntitiesFirstPage)
                        ? [
                            allActions.clearEntitiesPagesCache(),
                            allActions.loadEntitiesFirstPage(),
                        ]
                        : [allActions.loadEntities()]));
                });
        }
    }
    FilterEffect.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: FilterEffect, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
    FilterEffect.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: FilterEffect });
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: FilterEffect, decorators: [{
                type: Injectable
            }] });
    return [FilterEffect];
}
//# sourceMappingURL=filter-entities.trait.effect.js.map