import { PostfixProps } from 'ngrx-traits';
import { ActionCreator, TypedAction } from '@ngrx/store/src/models';
declare type SetActions<T> = {
    /**
     * set entity in the store
     */
    set: ActionCreator<string, (props: T) => TypedAction<string>>;
};
export declare type SetEntityActions<Entity, J extends string> = PostfixProps<SetActions<Entity>, J>;
export declare type SetEntityState<Entity, J extends string> = {
    [key in `${J}`]?: Entity;
};
export declare type SetEntitySelectors<Entity, J extends string> = PostfixProps<{
    select: (state: SetEntityState<Entity, J>) => Entity;
}, J>;
export {};
